#define SCHEME_TUPLE	 0
#define SCHEME_ATTRIBUTE 1
#define FACT_TUPLE		 2
#define FACT_ATTRIBUTE	 3

#define NONE	-2
#define EOFTOKEN	99

class CTAInput;
class CEntityCache;

class CLandscapeTokenStream : public CStreamTokenizer {
protected:
	CTAInput		*m_taInputP;
	CEntityCache	*m_entityCacheP;	// A secondary reference to the main entity cache

	// push backed tokens 

	const char		*m_token1P, *m_token2P; 
	int				m_ttype3;

	// Start line no
	
	int				m_startLineno;

	void skipRecord(void);
	void parseAttributes(CLandscapeObject *targetP);

public:
	// triple values

	const char	*m_verbP;
	const char	*m_objectP;
	const char	*m_subjectP; 
	int			m_relations;
	
	CLandscapeTokenStream(CTAInput *taInputP); 

	int getStartLineno(void) const;
	
	int nextSection(void); 
	const char *getIncludeFile(void) const; 
	int nextSchemaTriple(void); 
	int nextFactTriple(void); 
	void processSchemeAttributes(void);
	void processFactAttributes(void);
};

